// ======================================================================
//
// menukey.cpp - keyboard keys that generate event #'s
// ~Chuck Karpiak
//
// copyright 1997 origin systems inc
//
// ======================================================================

#include "first.h"
#include "MenuKey.h"

#include "Bitmap.h"
#include "Iff.h"
#include "Mouse.h"

// ======================================================================

MenuKey::MenuKey(MenuElement *newParent, int maxWidth, int maxHeight, Iff *iff)
: MenuElement(newParent, maxWidth, maxHeight, NULL)
{
	key         = '\0';
	eventNumber = 0;
	load(iff);
}

// ----------------------------------------------------------------------

MenuKey::~MenuKey(void)
{
}

// ----------------------------------------------------------------------

void MenuKey::load(Iff *iff)
{
	if (iff)
	{
		MenuElement::load(iff);

		iff->seekChunk(TAG_INFO);
		key         = iff->read_int8();
		eventNumber = iff->read_int32();
		iff->exitChunk();
	}
}

// ----------------------------------------------------------------------
// hover event messages occur only once for each 'start' and 'stop'

IoResult MenuKey::event(IoEventStruct *event)
{
	if (menuRect.isInInclusive(event->mouseX, event->mouseY))
	{
		// start dragging?
		if (event->type == IoEventKeyChar && event->ch == key)
			menuEvent(eventNumber, this);
	}

	return MenuElement::event(event);
}

// ======================================================================
